<template>
  <div class="card">
    <div class="card-head">
      <slot name="header" :randNum="randNum" saluti="ciao">
        <h4>{{  item.name  }}</h4>
        <hr />
        rand internal number: {{  randNum  }}
      </slot>
    </div>
    <div class="container">
      <p :style="{ color: descriptionColor }">{{  description  }}</p>
    </div>
    <div class="card-footer">
      <button @click="buttonClicked(item.id)" type="button">Seleziona</button>
    </div>
  </div>
</template>

<script>

export default {
  name: 'ProductCard',

  props: {
    item: Object,
    descriptionColor: {
      type: String,
      default: 'red',
    },
  },

  data() {
    return {
      randNum: Math.random(),
    };
  },
  computed: {
    description() {
      return this.item.short_description.substring(0, 20);
    },
  },
    methods: { 
      buttonClicked(id) {
+      console.log('id', id);
+      this.$emit('button-click', id);

      },
      getDescription(desc) {
        return desc.substring(0, 20);
      },
    },
  };

</script>

<style scoped>
.card {
  width: 50%;
  box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2);
  transition: 0.3s;
  margin: 2em auto;
}

.card:hover {
  box-shadow: 0 8px 16px 0 rgba(0, 0, 0, 0.2);
}

.card-footer {
  display: flex;
  justify-content: space-around;
  padding: 1.2em 0;
}
hr {
  background-color: #999;
  border-width: 0;
  color: #999;
  height: 1px;
  line-height: 0;
  margin: 0.5em 0;
  text-align: center;
}
h4 {
  text-align: center;
  margin: auto;
  padding: 1em;
  font-weight: bold;
}
a {
  text-decoration: none;
  color: green;
}
a:hover {
  cursor: pointer;
}

button {
  background-image: linear-gradient(#42a1ec, #0070c9);
  border: 1px solid #0077cc;
  border-radius: 4px;
  box-sizing: border-box;
  color: #ffffff;
  cursor: pointer;
  direction: ltr;
  display: block;
  font-family: 'SF Pro Text', 'SF Pro Icons', 'AOS Icons', 'Helvetica Neue', Helvetica,
    Arial, sans-serif;
  font-size: 17px;
  font-weight: 400;
  letter-spacing: -0.022em;
  line-height: 1.47059;
  min-width: 30px;
  overflow: visible;
  padding: 4px 15px;
  text-align: center;
  user-select: none;
  -webkit-user-select: none;
  touch-action: manipulation;
  white-space: nowrap;
}

button:disabled {
  cursor: default;
  opacity: 0.3;
}

button:hover {
  background-image: linear-gradient(#51a9ee, #147bcd);
  border-color: #1482d0;
  text-decoration: none;
}

button:active {
  background-image: linear-gradient(#3d94d9, #0067b9);
  border-color: #006dbc;
  outline: none;
}

button:focus {
  box-shadow: rgba(131, 192, 253, 0.5) 0 0 0 3px;
  outline: none;
}
</style>
